/***** interface.h ************************************************
 * Description: Header file for user interface.
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * File created on Sun Jun 20 13:07:28 2004.
 *****************************************************************/

/* define argument container */
typedef struct args{
    char *i;          /* name of first input file */
    char *j;          /* name of second input file */
    char *o;          /* name of output file */
    float O;          /* gap opening score */
    float E;          /* gap extension score */
    float A;          /* match score */
    float I;          /* mismatch score */
    char *m;          /* external score matrix */
    int p;            /* protein sequence */
    int a;            /* print alignments? */
    int l;            /* line length */
    int L;            /* print fragement list */
    int n;            /* number of alignments to return */
    int s;            /* return <= n alignments with score >= s */
    int k;            /* maximal number of errors */
    int r;            /* include reverse sequence in search? */
    int h;            /* help message? */
    int v;            /* print program information? */
    int e;            /* error message? */
} Args;

Args getArgs(int argc, char *argv[]);
void printUsage(char *version);
void printSplash(char *version);
