#!/usr/bin/awk -f
# Date July 12, 2017 (version 0.1)
BEGIN{
    program = "blast2dot.awk"
    version = "0.1"
    if(h){
	printUsage(program)
    }
    if(v){
	printVersion(program, version)
    }
    numAcc = 0
    printf "graph G {\n"
    printf "node [style=filled, color=lightsalmon]\n"
}
{
    if(!names[$1]){
	names[$1] = 1
	acc[numAcc++] = $1
    }
    mat[$1, $2] = 1
    if($1 != $2){
	found[$1] = 1
	found[$2] = 1
    }
}
END{
    for(i=0; i<numAcc; i++){
	for(j=0; j<numAcc; j++){
	    if(i != j){
		if(mat[acc[i], acc[j]]){
		    printf "\t%s -- %s [dir=", acc[i], acc[j]
		    if(mat[acc[i], acc[j]] && mat[acc[j], acc[i]]){
			printf "both"
			mat[acc[i], acc[j]] = 0
			mat[acc[j], acc[i]] = 0
		    }else{
			printf "forward"
			mat[acc[i], acc[j]] = 0
		    }
		    printf "]\n"
		}
	    }
	}
    }
    if(singletons){
	printf "node [style=filled, color=lightgray]\n"
	for(a in names)
	    if(!found[a])
		printf "\t%s\n", a
    }
    if(!stopped)
	printf "}\n"
}
function printUsage(prog){
    	printf "Usage: awk -f %s [-v singletons=0|1 -v h=1 -v v=1]\n", prog
	printf "Purpose: Convert BLAST output to dot code for plotting with GraphViz.\n"
	printf "Options:\n"
	printf "\t[singletons\tinclude proteins without homologs]\n"
	printf "\t[h\t\thelp]\n"
	printf "\t[v\t\tversion]\n"
	stopped = 1
	exit
}
function printVersion(prog, ver){
    	printf "%s %s\n", prog, ver
	printf "Written by Bernhard Haubold.\n"
	printf "Distributed under the GNU General Public License.\n"
	printf "Please send bug reports to haubold@evolbio.mpg.de\n"
	stopped = 1
	exit
}
