#!/usr/bin/awk -f
# Date: July 12, 2017 (version 0.1)
BEGIN{
    program = "dotPlotFilter.awk"
    version = "0.1"
    if(h){
	printUsage(program)
    }
    if(v){
	printVersion(program, version)
    }
    filter = "sort -n > dotPlotFilter.tmp"
    data = 0
}
{
    data = 1
    if(/1:/ && /2:/){
	numX = numY = 0
	n = split($0,arr,"|")
	len = arr[1]
	for(i=2;i<=n;i++){
	    if(arr[i] ~ /1:/){
		split(arr[i],p1,":")
		x1[numX] = p1[2]
		x2[numX] = p1[2] + len - 1
		numX++
	    }else{
		if(arr[i] ~ /2:/){
		    split(arr[i],p1,":")
		    y1[numY] = p1[2]
		    y2[numY] = p1[2] + len - 1
		    numY++
		}
	    }
	}
	for(i=0;i<numX;i++){
	    for(j=0;j<numY;j++){
		print x1[i] "\t" y1[j] "\t" x2[i] "\t" y2[j] | filter
	    }  
	}
    }
}
END{
    if(!data)
	exit
    close(filter)
    while(getline < "dotPlotFilter.tmp"){
	sx1 = $1
	sy1 = $2
	sx2 = $3
	sy2 = $4
	printf("%d\t%d\n%d\t%d\n\n", sx1, sy1, sx2, sy2)
    }
    system("rm dotPlotFilter.tmp")
}

function printUsage(prog){
    	printf "Usage: awk -f %s [-v h=1 -v v=1]\n", program
	printf "Purpose: Filter output from repeater for creation of dot plot\n"
	printf "Example:\n"
	printf "\tcat dmAdhAdhdup.fasta dgAdhAdhdup.fasta |\n"
	printf "\trepeater -m 7 -q 1                      |\n"
	printf "\tawk -f dotPlotFilter.awk                |\n"
	printf "\tgnuplot -p -e 'plot \"< cat\" t \"\" w l'\n"
	printf "Options:\n"
	printf "\t[h\thelp]\n"
	printf "\t[v\tversion]\n"
	exit
}

function printVersion(prog, ver){
    	printf "%s %s\n", prog, ver
	printf "Written by Bernhard Haubold.\n"
	printf "Distributed under the GNU General Public License.\n"
	printf "Please send bug reports to haubold@evolbio.mpg.de\n"
	exit
}
