#!/usr/bin/awk -f
# Date: July 12, 2017 (version 0.1)
BEGIN{
    program = "fasta2tab.awk"
    version = "0.1"
    if(h){
	printUsage(program)
    }
    if(v){
	printVersion(program, version)
    }
}
/>/ && NR==1{printf "%s\t", $1}
/>/ && NR>1 {printf "\n%s\t", $1}
!/>/        {printf "%s", $1}

function printUsage(prog){
    	printf "Usage: awk -f %s [-v h=1 -v v=1]\n", prog
	printf "Purpose: Convert FASTA format to tabular format\n"
	printf "Options:\n"
	printf "\t[h\thelp]\n"
	printf "\t[v\tversion]\n"
	exit
}

function printVersion(prog, ver){
    	printf "%s %s\n", prog, ver
	printf "Written by Bernhard Haubold.\n"
	printf "Distributed under the GNU General Public License.\n"
	printf "Please send bug reports to haubold@evolbio.mpg.de\n"
	exit
}
