#!/usr/bin/awk -f
# Date: July 12, 2017 (version 0.1)
BEGIN{
    program = "percentDiff.awk"
    version = "0.1"
    if(h){
	printUsage(program)
    }
    if(v){
	printVersion(program, version)
    }
    while(getline < "aa.txt")
	if(!/#/)
	    p[++l] = $1;
}
{
    sum += $(NR+1)*p[NR];
}
END{
    if(!stopped)
	print (1-sum)*100;
}

function printUsage(prog){
    	printf "Usage: awk -f %s [-v h=1 -v v=1]\n", prog
	printf "Purpose: Compute the percent difference implied by a PAM mutation matrix.\n"
	printf "Options:\n"
	printf "\t[h\thelp]\n"
	printf "\t[v\tversion]\n"
	stopped = 1
	exit
}

function printVersion(prog, ver){
    	printf "%s %s\n", prog, ver
	printf "Written by Bernhard Haubold.\n"
	printf "Distributed under the GNU General Public License.\n"
	printf "Please send bug reports to haubold@evolbio.mpg.de\n"
	stopped = 1
	exit
}
