#!/usr/bin/awk -f
# Date: July 12, 2017 (version 0.1)
BEGIN{
    program = "shuffle.awk"
    version = "0.1"
    if(h){
	printUsage(program)
    }
    if(v){
	printVersion(program, version)
    }
    if(!seed)
	srand()
    else
	srand(seed)
}
{
    arr[n++] = $0;
}END{
    for(i=n; i>0; i--){
	r = int(rand() * i)
	tmp = arr[r]
	arr[r] = arr[i-1]
	arr[i-1] = tmp
    }
    for(i=0; i<n; i++)
	print arr[i]
 }

function printUsage(prog){
    	printf "Usage: awk -f %s [-v seed=<seed> -v h=1 -v v=1]\n", prog
	printf "Purpose: Shuffle a set of objects.\n"
	printf "Options:\n"
	printf "\t[seed\tseed for random number generator]\n"
	printf "\t[h\thelp]\n"
	printf "\t[v\tversion]\n"
	exit
}

function printVersion(prog, ver){
    	printf "%s %s\n", prog, ver
	printf "Written by Bernhard Haubold.\n"
	printf "Distributed under the GNU General Public License.\n"
	printf "Please send bug reports to haubold@evolbio.mpg.de\n"
	exit
}
