#!/usr/bin/awk -f
# Date: July 12, 2017 (version 0.1)
BEGIN{
    program = "simOrf.awk"
    version = "0.1"
    if(h){
	printUsage(program)
    }
    if(v){
	printVersion(program, version)
    }
    srand(seed)
    t = 1/21
    for(i=0; i<n; i++){
	c = 0
	while(rand() > t)
	    c++
	print c + 1 # include stop codon
    }
}

function printUsage(prog){
    printf "Usage: awk -f %s [-v seed=<seed> -v h=1 -v v=1]\n", prog
    printf "Purpose: Simulate the lengths of open reading frames in random protein sequences.\n"
    printf "Options:\n"
    printf "\t[seed\tseed for random number generator]\n"
    printf "\t[h\thelp]\n"
    printf "\t[v\tversion]\n"
    exit
}

function printVersion(prog, ver){
    printf "%s %s\n", prog, ver
    printf "Written by Bernhard Haubold.\n"
    printf "Distributed under the GNU General Public License.\n"
    printf "Please send bug reports to haubold@evolbio.mpg.de\n"
    exit
}
