/***** interface.h ************************************************
 * Description: Header file for user interface.
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * File created on Sun Jun 20 13:07:28 2004.
 *****************************************************************/
#define DEFAULT_L 70 /* default length of output lines */

/* define argument container */
typedef struct args{
  char *f;          /* name of position file */
  char *r;          /* regions */
  int l;            /* length of output lines */
  int h;            /* help message? */
  int s;            /* splice? */
  int v;            /* version information */
  int e;            /* error message? */
  int numInputFiles;
  char **inputFiles;
} Args;

Args *getArgs(int argc, char *argv[]);
void printUsage(char *version);
char **processPatterns(char *patterns, int *patternSize, int *residues);
void printSplash(char *version);
