/***** interface.h ************************************************
 * Description: Header file for user interface.
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * File created on Sun Jun 20 13:07:28 2004.
 *****************************************************************/
#ifndef INTERFACE
#define INTERFACE

/* define argument container */
typedef struct args{
  int p;        /* population size */
  int n;        /* sample size */
  int g;        /* generations */
  int s;        /* seed of random number generator */
  short m;      /* show most recent common ancestor? */
  short f;      /* mark forward? */
  char *a;      /* ancestral lineages */
  short h;      /* help message? */
  short e;      /* error message? */
  char *o;      /* output file */
  char *t;      /* test file */
} Args;
 
Args *getArgs(int argc, char *argv[]);
void printUsage(char *version);

#endif
