/***** aa.c ***************************************
 * Description: Generate amino acid lists.
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Wed Nov  2 10:44:12 2016
 **************************************************/
#include "eprintf.h"

char **getAa3(){
  char **aa;

  aa = (char **)emalloc(21 * sizeof(char *));
  aa[0]  = "Phe";
  aa[1]  = "Leu";
  aa[2]  = "Ser";
  aa[3]  = "Tyr";
  aa[4]  = "Cys";
  aa[5]  = "Trp";
  aa[6]  = "Pro";
  aa[7]  = "His";
  aa[8]  = "Gln";
  aa[9]  = "Arg";
  aa[10] = "Ile";
  aa[11] = "Met";
  aa[12] = "Thr";
  aa[13] = "Asn";
  aa[14] = "Lys";
  aa[15] = "Val";
  aa[16] = "Ala";
  aa[17] = "Asp";
  aa[18] = "Glu";
  aa[19] = "Gly";
  aa[20] = "Ter";

  return aa;
}

char **getAa1(){
  char **aa;

  aa = (char **)emalloc(21 * sizeof(char *));
  aa[0]  = "F"; /* Phe */
  aa[1]  = "L"; /* Leu */
  aa[2]  = "S"; /* Ser */
  aa[3]  = "Y"; /* Tyr */
  aa[4]  = "C"; /* Cys */
  aa[5]  = "W"; /* Trp */
  aa[6]  = "P"; /* Pro */
  aa[7]  = "H"; /* His */
  aa[8]  = "Q"; /* Gln */
  aa[9]  = "R"; /* Arg */
  aa[10] = "I"; /* Ile */
  aa[11] = "M"; /* Met */
  aa[12] = "T"; /* Thr */
  aa[13] = "N"; /* Asn */
  aa[14] = "K"; /* Lys */
  aa[15] = "V"; /* Val */
  aa[16] = "A"; /* Ala */
  aa[17] = "D"; /* Asp */
  aa[18] = "E"; /* Glu */
  aa[19] = "G"; /* Gly */
  aa[20] = "*"; /* Ter */

  return aa;
}

