/***** ktree.h ************************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Sat Apr 15 12:58:43 2017
 **************************************************/
#ifndef KTREE
#define KTREE

#include "sequenceData.h"
#include "interface.h"

#define MAX_PATTERNS 50000 /* maximum number of patterns */

typedef struct node{
  int id;              /* pattern identifier */
  int nId;             /* node identifier */
  int depth;           /* number of characters on path from root to node */
  char c;              /* character labelling incoming edge */
  float x;             /* x-coordinate */
  struct node *fail;   /* failure link */
  struct node *out;    /* output link */
  struct node *child;
  struct node *sibling;
} KNode; 

typedef struct ktree{
  Sequence *pattern;
  KNode *root;
} KTree;

KTree *getKeywordTree(Args *args);

#endif
