/***** naiveMatcher.c *****************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Thu Jun  8 23:42:53 2017
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include "interface.h"
#include "eprintf.h"
#include "sequenceData.h"

void naive(char *p, char *t);

void scanFile(int fd, Args *args){
  Sequence *seq, *pat;
  int fdp;

  seq = readFasta(fd);
  if(args->P){
    fdp = open(args->P, 0);
    if(fdp < 0){
      printf("ERROR: Could not open file %s\n", args->P);
      exit(-1);
    }
    pat = readFasta(fdp);
    if(pat == NULL){
      printf("ERROR: Could not read sequence from file %s\n", args->P);
      exit(-1);
    }
    pat->seq[pat->len-1] = '\0'; /* cut off sentinel character */
    args->p = pat->seq;
    close(fdp);
  }
  naive(args->p,seq->seq);
  freeSequence(seq);
}

int main(int argc, char *argv[]){
  int i;
  char *version;
  Args *args;    /* command line arguments */
  int fd;        /* file descriptor */

  version = "0.2";
  setprogname2("naiveMatcher");
  args = getArgs(argc, argv);
  if(args->v)
    printSplash(version);
  if(args->h || args->e)
    printUsage(version);
  if(args->numInputFiles == 0){
    fd = 0;
    scanFile(fd, args);
  }else{
    for(i=0;i<args->numInputFiles;i++){
      fd = open(args->inputFiles[i],0);
      scanFile(fd, args);
      close(fd);
    }
  }
  free(args);
  free(progname());
  return 0;
}
