/***** interface.h ************************************************
 * Description: Header file for user interface.
 * Author: Bernhard Haubold, bernhard.haubold@fh-weihenstephan.de
 * File created on Sun Jun 20 13:07:28 2004.
 *****************************************************************/

/* define argument container */
typedef struct args{
  char *i;          /* name of first input file */
  char *o;          /* name of output file */
  int a;            /* maximal repeats? */
  int p;            /* print program information */
  int c;            /* ignore case */
  int n;            /* number of characters printed from header line */
  int s;            /* separate input sequences */
  int r;            /* include reverse strand? */
  int m;            /* minimal length of repeat */
  int M;            /* maximal length of repeat */
  int q;            /* quiet mode */
  int h;            /* help message? */
  int e;            /* error message? */
} Args;

Args *getArgs(int argc, char *argv[]);
void printUsage(char *version);
void printSplash(char *version);
