#ifndef INTERFACE
#define INTERFACE

#define DEFAULT_I 10 /* default number of iterations */
#define DEFAULT_N 8  /* default sample size */
#define DEFAULT_M 0. /* default mean */
#define DEFAULT_D 1. /* default standard deviation */

/* define argument container */
typedef struct args{
  char h;   /* help message? */
  char v;   /* version message? */
  char e;   /* error message? */
  int i;    /* number of iterations */
  int n;    /* sample size */
  int s;    /* seed for random number generator */
  double m; /* mean */
  double d; /* standard deviation */
} Args;

Args *getArgs(int argc, char *argv[]);
void printUsage(char *version);
void printSplash(char *version);

#endif
