/***** mcTest.c ***********************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Thu Dec 15 11:45:52 2016
 **************************************************/
#include <stdlib.h>
#include <gsl/gsl_statistics_double.h>
#include "gsl_rng.h"
#include "testMeans.h"
#include "eprintf.h"

Result *mcTest(Result *res, gsl_rng *ran, int it, double *s1, int n1, double *s2, int n2){
  double *rs, tmp, d, d0, m1, m2;
  int i, j, n, r, c;
  
  m1 = gsl_stats_mean(s1,1,n1);
  m2 = gsl_stats_mean(s2,1,n2);
  d0 = m1 > m2 ? m1 - m2 : m2 - m1;
  res->m1 = m1;
  res->m2 = m2;
  rs = (double *)emalloc((n1 + n2)*sizeof(double));
  n = 0;
  for(i=0;i<n1;i++)
    rs[n++] = s1[i];
  for(i=0;i<n2;i++)
    rs[n++] = s2[i];
  c = 0;
  for(i=0;i<it;i++){
    for(j=n;j>0;j--){
      r = gsl_rng_uniform_int(ran,j);
      tmp = rs[r];
      rs[r] = rs[j-1];
      rs[j-1] = tmp;
    }
    m1 = gsl_stats_mean(rs,1,n1);
    m2 = gsl_stats_mean(rs+n1,1,n2);
    d = m1 > m2 ? m1 - m2 : m2 - m1;
    if(d >= d0)
      c++;
  }
  if(c == 0)
    c++;
  res->p = (double) c / (double) it;
  free(rs);
  return res;
}
