/***** traverse.c *********************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Mon Sep 17 08:14:32 2012
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "tree.h"

void printNode(Node *np);

void printInorder(Node *np){
  Node *child;

  if(np != NULL){
    printInorder(np->left);
    printNode(np);
    if(np->left){
      child = np->left;
      while(child->right){
	printInorder(child->right);
	child = child->right;
      }
      printInorder(child->right);
    }
  }
}

void printPreorder(Node *np){
  Node *child;

  if(np != NULL){
    printNode(np);
    printPreorder(np->left);
    if(np->left){
      child = np->left;
      while(child->right){
	printPreorder(child->right);
	child = child->right;
      }
      printPreorder(child->right);
    }
  }
}

void printPostorder(Node *np){
  Node *child;

  if(np != NULL){
    printPostorder(np->left);
    if(np->left){
      child = np->left;
      while(child->right){
	printPostorder(child->right);
	child = child->right;
      }
      printPostorder(child->right);
    }
    printNode(np);
  }
}

void printNode(Node *np){
  printf("%2d",np->id);
  if(np->label != NULL)
    printf("\t%s\t",np->label);
  if(np->parent)
    printf("%2d",np->parent->id);
  printf("\t%5.1f",np->dist);
  if(np->parent == NULL && np->left != NULL)
    printf("\troot\n");
  else if(np->parent != NULL && np->left == NULL)
    printf("\tleaf\n");
  else if(np->parent == NULL && np->left == NULL)
    printf("\troot/leaf\n");
  else
    printf("\tinternal\n");
}
