/***** var.c **************************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Fri Nov 11 12:00:32 2016
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "interface.h"
#include "eprintf.h"

void scanFile(FILE *fp, Args *args){
  long n = 0;
  long i;
  long maxN = 1;
  double x, mean, sx, sxx, var, diff;
  double *arr = emalloc(maxN * sizeof(double));
  
  while(fscanf(fp,"%lf",&x) != EOF){
    arr[n++] = x;
    if(n == maxN){
      maxN *= 2;
      arr = erealloc(arr, maxN * sizeof(double));
    }
  }
  arr = erealloc(arr, n * sizeof(double));
  mean = 0;
  for(i=0;i<n;i++)
    mean += arr[i];
  mean /= n;
  sx = sxx = 0.;
  for(i=0;i<n;i++){
    diff = arr[i] - mean;
    sx += diff;
    sxx += diff * diff;
  }
  var = (sxx-sx*sx/n)/(n-1);
  printf("#mean\tvar\n");
  printf("%e\t%e\n",mean,var);
  free(arr);
}

int main(int argc, char *argv[]){
  int i;
  char *version;
  Args *args;
  FILE *fp;

  version = "0.1";
  setprogname2("var");
  args = getArgs(argc, argv);
  if(args->v)
    printSplash(version);
  if(args->h || args->e)
    printUsage(version);
  if(args->numInputFiles == 0){
    fp = stdin;
    scanFile(fp, args);
  }else{
    for(i=0;i<args->numInputFiles;i++){
      fp = efopen(args->inputFiles[i],"r");
      scanFile(fp, args);
      fclose(fp);
    }
  }
  free(args);
  free(progname());
  return 0;
}

